from cgi import print_arguments
from ntpath import join
from db_connet import *
from tool import *

# 此專案轉由sevenz處理，故取消程式排程  #

################################
#    回補過往試吃、試吃轉正數量    #
################################
def writeback_old_try():
    sql = f"""
    SELECT
        DATE_FORMAT(create_date, '%Y') AS order_year,
        DATE_FORMAT(create_date, '%m') AS order_month,
        COUNT(id) AS count
    FROM 
        order_try_list
    WHERE
        DATE_FORMAT(create_date, '%Y%m') >= DATE_FORMAT( CURDATE(), '%Y%m')
    GROUP BY
        YEAR(create_date),
        MONTH(create_date)
    """
    try_data = select_db(sql,'baby')

    for d in try_data:
        sql = f"""
        INSERT INTO `omo_try_order`(`id`, `order_year`, `order_month`, `try_num`, `order_num`, `create_at`, `update_at`) VALUES (NULL,'{d['order_year']}','{d['order_month']}','{d['count']}',NULL,'{now()}',NULL)
        """
        logTxt(sql)
        insert_db(sql,'docker-lake')  

################################
#       統計前三個月至今          #
#       試吃、試吃轉正數量        #
################################
def sync_try():
    for r_momth in range(3,-1,-1):
        sql = f'''
        SELECT 
            mid
        FROM 
            `order_try_list`
        WHERE 
            DATE_FORMAT(create_date, '%Y-%m') = date_format(DATE_SUB(curdate(), INTERVAL {r_momth} month),'%Y-%m')
        '''
        res = select_db(sql,'baby')
        mid_ary = []
        for i in res:
            mid_ary.append(i['mid'])
        mid_str= ",".join(map(str,mid_ary))

        sql = f'''
        SELECT 
            date_format(DATE_SUB(curdate(), INTERVAL {r_momth} month),'%Y') as order_year,
            date_format(DATE_SUB(curdate(), INTERVAL {r_momth} month),'%m') as order_month,
            count(id) as count
        FROM 
            `order_list`
        WHERE
            mid in ({mid_str}) and
            category_name LIKE '%彌月試吃%' and
            order_memo LIKE '來自於%' and
            create_date >= date_format(DATE_SUB(curdate(), INTERVAL {r_momth} month),'%Y-%m-01')
        '''
    
        data = select_db(sql,'baby')
        for i in data:
            sql = f"""
                UPDATE 
                    `omo_try_order` 
                SET 
                    `order_num` = '{i['count']}',
                    `update_at` = '{now()}'
                WHERE 
                    order_year = '{i['order_year']}' AND
                    order_month = '{i['order_month']}'
            """
            logTxt(sql)
            update_db(sql,'docker-lake')


tz = timezone(timedelta(hours=+8))
yy = datetime.now(tz).strftime("%Y")
mm = datetime.now(tz).strftime("%m")

sql = f"""
    SELECT count(1) as count
    FROM omo_try_order
    WHERE order_year = '{yy}' AND order_month = '{mm}'
"""
res = rowcount(sql,'docker-lake')
# 找到新月份，寫入新月份試吃單
if res == 0 :
    writeback_old_try()    


sync_try()

